{*******************************************************}
{                                                       }
{       K8074 Interface API                             }
{       (C) Velleman Projects                           }
{                                                       }
{                                                       }
{*******************************************************}
unit K8074;

interface

uses
  Windows;

{ Prototypes }
function OpenDevice(szPort: LPCSTR): THandle; stdcall;
function SendCommand(hDevice: THandle; bAddr, bCmd, bParam: BYTE): BOOL; stdcall;
function EmergencyStop(hDevice: THandle): BOOL; stdcall;
function DisplayAddress(hDevice: THandle): BOOL; stdcall;
function SetRelay(hDevice: THandle; bAddr: BYTE; dwRelayId: DWORD): BOOL; stdcall;
function ClearRelay(hDevice: THandle; bAddr: BYTE; dwRelayId: DWORD): BOOL; stdcall;
function ToggleRelay(hDevice: THandle; bAddr: BYTE; dwRelayId: DWORD): BOOL; stdcall;
function SetAddress(hDevice: THandle; bOldAddr, bNewAddr: BYTE): BOOL; stdcall;
function ForceAddressReset(hDevice: THandle): BOOL; stdcall;
function SendByte(hDevice: THandle; bAddr, bMask: BYTE): BOOL; stdcall;
procedure CloseDevice(hDevice: THandle); stdcall;
function GetDllVersion(): DWORD; stdcall;

const
  k8061dll = 'K8074.dll';

implementation

{ Externals from K8061.dll }

function OpenDevice; external k8061dll name 'OpenDevice';
function SendCommand; external k8061dll name 'SendCommand';
function EmergencyStop; external k8061dll name 'EmergencyStop';
function DisplayAddress; external k8061dll name 'DisplayAddress';
function SetRelay; external k8061dll name 'SetRelay';
function ClearRelay; external k8061dll name 'ClearRelay';
function ToggleRelay; external k8061dll name 'ToggleRelay';
function SetAddress; external k8061dll name 'SetAddress';
function ForceAddressReset; external k8061dll name 'ForceAddressReset';
function SendByte; external k8061dll name 'SendByte';
procedure CloseDevice; external k8061dll name 'CloseDevice';
function GetDllVersion; external k8061dll name 'GetDllVersion';

end.

