using System;
using System.Runtime.InteropServices;

namespace Velleman.Kits
{
    internal static class K8074Native
    {
        [DllImport("K8074.dll")]
        internal static extern int OpenDevice(string portName);

        [DllImport("K8074.dll")]
        internal static extern int SendCommand(int deviceId, Byte address, Byte cmd, Byte param);

        [DllImport("K8074.dll")]
        internal static extern int EmergencyStop(int deviceId);

        [DllImport("K8074.dll")]
        internal static extern int DisplayAddress(int deviceId);

        [DllImport("K8074.dll")]
        internal static extern int SetRelay(int deviceId, byte address, int relayId);

        [DllImport("K8074.dll")]
        internal static extern int ClearRelay(int deviceId, byte address, int relayId);

        [DllImport("K8074.dll")]
        internal static extern int ToggleRelay(int deviceId, byte address, int relayId);

        [DllImport("K8074.dll")]
        internal static extern int SetAddress(int deviceId, byte oldAddress, byte newAddress);

        [DllImport("K8074.dll")]
        internal static extern int ForceAddressReset(int deviceId);

        [DllImport("K8074.dll")]
        internal static extern int SendByte(int deviceId, byte address, byte bMask);

        [DllImport("K8074.dll")]
        internal static extern void CloseDevice(int deviceId);

        [DllImport("K8074.dll")]
        internal static extern int GetDllVersion();
    }

    class K8074
    {
        // write your own wrapper class around K8074Native functions
    }
}