#ifndef _K8074_
#define _K8074_

#ifdef __cplusplus
extern "C" {
#endif

#undef UNICODE /* not using unicode */
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define STX  0x0D

#define PARAM_EMPTY  0x00

#define K8074_SET_ADDRESS         0x41 // 'A'
#define K8074_SEND_BYTE           0x42 // 'B'
#define K8074_CLEAR_RELAY         0x43 // 'C'
#define K8074_DISPLAY_ADDRESS     0x44 // 'D'
#define K8074_EMERGENCY_STOP      0x45 // 'E'
#define K8074_FORCE_RESET         0x46 // 'F'
#define K8074_SET_RELAY           0x53 // 'S'
#define K8074_TOGGLE_RELAY        0x54 // 'T'

typedef struct
{
	BYTE bSTX;
	BYTE bAddress;
	BYTE bCmd;
	BYTE bParam;
	BYTE bChecksum;
}
K8074_PACKET, *LPK8074_PACKET;

typedef struct
{
	K8074_PACKET packet[6];
}
K8074_REQUEST, *LPK8074_REQUEST;

HANDLE
WINAPI
OpenDevice(
	LPCSTR szPort
	);

VOID
WINAPI
CloseDevice(
	HANDLE hDevice
	);

DWORD
WINAPI
GetDllVersion(
	VOID);

BOOL
WINAPI
SendCommand(
	HANDLE hDevice,
	BYTE address,
	BYTE cmd,
	BYTE param
	);

BOOL 
WINAPI
EmergencyStop(
	HANDLE hDevice
	);

BOOL
WINAPI
DisplayAddress(
	HANDLE hDevice
	);

BOOL
WINAPI
SetRelay(
	HANDLE hDevice,
	BYTE address,
	DWORD dwRelayId
	);

BOOL
WINAPI
ClearRelay(
	HANDLE hDevice,
	BYTE address,
	DWORD dwRelayId
	);

BOOL
WINAPI
ToggleRelay(
	HANDLE hDevice,
	BYTE address,
	DWORD dwRelayId
	);

BOOL
WINAPI
SetAddress(
	HANDLE hDevice,
	BYTE oldAdress,
	BYTE newAddress
	);

BOOL
WINAPI
ForceAddressReset(
	HANDLE hDevice
	);

BOOL
WINAPI
SendByte(
	HANDLE hDevice,
	BYTE address,
	BYTE bMask
	);

VOID
WINAPI
CloseDevice(
	HANDLE hDevice
	);

#ifdef __cplusplus
}
#endif

#endif /* _K8074_ */